Unit HipMain;
{ ⥭ ⠫ Hipparcos }

Interface { 䥩᭠   }

 { ᯮ  ᨨ ⠫ Hipparcos }
 Const HipparcosName : string[79] = 'D:\CATALOGS\HIPARCOS\hip_main.dat';
       HipNumOfStars = 118218;

 { ⮢ ⠭ 䫠  稨 ଠ樨 }
 Const NoRaDe  =  1; {     न }
       NoPlx   =  2; {    ࠫ }
       Nopm    =  4; {    ᮡ⢥  }
       NoVMag  =  8; {     稭 }
       NoB_V   = 16; {    ⥫ 梥 }

 Type THipparcos=record

      { 䨪 }
      HIP : longint; {    Hipparocs }

      { ஬᪠ ଠ }
      RAdeg,DEdeg : double; { ਠ न  ࠤ }
      Plx         : double; { ਣ᪨ ࠫ  mas }
      pmRa,pmDE   : double; { ᮡ⢥  ma*cos(d)  md  mas/ }

      AstroRef    : char;      {    ⥬ }

      { ⮬᪠ 䮬 }
      VMag     : single; {  .  誠 ᮭ }
      B_V      : single; { ⥫ 梥 B-V  誠 ᮭ }

     sigma : record { 訡 ᮮ. 稭 }
               RAdeg,DEdeg : double;
               Plx         : double;
               pmRa,pmDE   : double;
             end;

      Sp : array[0..9] of char; {  ᯥࠫ  }

      Info : integer; { ⮢ 䫠 ᢨ ଠ樨 }

     end;

  Procedure OpenHipparcosMain;  { ⨥ 䠩 ⠫ }
  Procedure CloseHipparcosMain; { ⨥ 䠩 ⠫ }

  { ⥭  窨 ⠫:
     頥  s,
    頥 false  ⨦  䠩 }
  Function ReadHipparcosMain(var s : THipparcos):boolean;


Implementation { ᯮ⥫쭠   }

 Uses Strings;

 Type THipStr=array[1..452] of char; {   窨 ⠫ }

 Var f : file of THipStr; {  ६  ⥭ ⠫ }

 { ⨥ 䠩 ⠫  ० "⮫쪮 ⥭" }
 Procedure OpenHipparcosMain;
 begin
  FileMode:=0; {Read only}
  assign(f,HipparcosName); reset(f);
 end;

 { ⨥ 䠩 ⠫ }
 Procedure CloseHipparcosMain;
 begin
  close(f);
 end;

 { ⥭   }
 Function ReadHipparcosMain(var s : THipparcos):boolean;
 {  ६ 㭪樨 }
 var hs : THipStr; { 窠 ⠫ }
     st : array [0..15] of char; { ᯮ⥫  }
     code : integer; {  訡  ८ࠧ  ᫮ }
     i : integer; { ᯮ⥫쭠 ६ }
 begin
  { ᫨ ⨣  䠩  頥 False }
  if eof(f) then ReadHipparcosMain:=false else
  begin

   ReadHipparcosMain:=true; {  㭪樨 - true }
   read(f,hs); { ⥭  窨 ⠫ }

   with s do { 樨  ﬨ  s }
   begin

    info:=0; { 㫥  ⮢ 䫠 }

    { +  @ 砥 .
      + 楤 Val ८ࠧ ⥪⮢ ப  ᫮,
        code ⫨砥    砥 訡 ८ࠧ.
      + 㭪 StrLCopy  ப  㪠
        ⮢ 樨  ⢠ . }

    {   12 , 稭  3- -   HIP }
    Val(StrLCopy(st,@hs[3],12),hip,code);

    { ⥭ न:  12   52   65 樨 }
    Val(StrLCopy(st,@hs[52],12),RAdeg,code); if code<>0 then info := NoRaDe;
    Val(StrLCopy(st,@hs[65],12),DEdeg,code); if code<>0 then info := NoRaDe;

    { ⥭ ࠫ - 7   80- 樨 }
    Val(StrLCopy(st,@hs[80],7),Plx,code); if code<>0 then info := info or NoPlx;

    { ⥭ ᮡ⢥ :  8   88   97 樨 }
    Val(StrLCopy(st,@hs[88],8),pmRA,code); if code<>0 then info := info or Nopm;
    Val(StrLCopy(st,@hs[97],8),pmDE,code); if code<>0 then info := info or Nopm;
    s.AstroRef:=hs[78]; {  ⭮  }

    { ⥭ .稭  ⥫ 梥 B-V  誠 ᮭ }
    Val(StrLCopy(st,@hs[42],5),VMag,code); if code<>0 then info := info or NoVMag;
    Val(StrLCopy(st,@hs[246],6),B_V,code); if code<>0 then info := info or NoB_V;
    { ⥭ 訡 ᮮ. 稭 }
    with sigma do begin

     if (info and NoRADE) = 0 then
     begin
      Val(StrLCopy(st,@hs[106],6),RAdeg,code); {   訡 ᥣ ,}
      Val(StrLCopy(st,@hs[113],6),DEdeg,code); { ᫨   ᠬ न}
     end;

     if (info and NoPlx) = 0 then
     begin
      Val(StrLCopy(st,@hs[120],6),Plx ,code);
     end;

     if (info and Nopm) = 0 then
     begin
      Val(StrLCopy(st,@hs[127],6),pmRA,code);
      Val(StrLCopy(st,@hs[134],6),pmDE,code);
     end;
    end; { with sigma }

    { ⥭   ᯥࠫ쭮  }
    for i:=0 to 9 do Sp[i]:=hs[436+i];

   end; { with s }
  end; { if eof(f) }
 end; { Function }


end.
